"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var solid_1 = require("@heroicons/react/20/solid");
var date_fns_1 = require("date-fns");
var react_1 = tslib_1.__importStar(require("react"));
var utils_1 = require("../utils");
var Select_1 = require("../../Select");
var Input_1 = require("../../Input");
var Button_1 = require("../../Button");
var CheckIcon_1 = tslib_1.__importDefault(require("@heroicons/react/24/outline/CheckIcon"));
var dayOfWeek = ['T2', 'T3', 'T4', 'T5', 'T6', 'T7', 'CN'];
var menuDay = [
    { id: 1, content: 'Hôm nay', active: true },
    { id: 2, content: 'Ngày hôm qua' },
    { id: 3, content: '7 ngày qua' },
    { id: 4, content: '30 ngày qua' },
    { id: 5, content: '90 ngày qua' },
    { id: 6, content: '365 ngày qua' },
];
function Calendar(_a) {
    var defaultDate = _a.defaultDate, disabledDate = _a.disabledDate, handleCancel = _a.handleCancel, handleResult = _a.handleResult, inputValue = _a.inputValue, max = _a.max, min = _a.min;
    var currentDate = (0, utils_1.formatDate)(new Date());
    var _b = (0, react_1.useState)(new Date().getFullYear()), currentYear = _b[0], setCurrentYear = _b[1];
    var _c = (0, react_1.useState)(new Date().getMonth()), currentMonth = _c[0], setCurrentMonth = _c[1];
    var _d = (0, react_1.useState)([]), calendar = _d[0], setCalendar = _d[1];
    var _e = (0, react_1.useState)(''), daySelected = _e[0], setDaySelected = _e[1];
    var checkToday = function (dayOfWeeks, curMonth) {
        var _a;
        var today = (_a = calendar.find(function (item) { return item.date === currentDate && item.currentMonth === curMonth; })) === null || _a === void 0 ? void 0 : _a.dayOfWeek;
        return today === dayOfWeeks;
    };
    (0, react_1.useEffect)(function () {
        var selectDate = function (inputValues, daySplit) {
            if (daySplit.length >= 3) {
                setDaySelected(inputValues);
                setCurrentMonth(parseInt(daySplit[1]) - 1);
                setCurrentYear(parseInt(daySplit[2]));
            }
        };
        if (inputValue) {
            // @ts-ignore
            var daySplit = inputValue === null || inputValue === void 0 ? void 0 : inputValue.split('-');
            selectDate(inputValue, daySplit);
        }
    }, [inputValue]);
    (0, react_1.useEffect)(function () {
        var calendars = (0, utils_1.createMonthCalendarWithAdjacentMonths)(currentYear, currentMonth);
        var selectedCalendar = calendars.map(function (item) { return (tslib_1.__assign(tslib_1.__assign({}, item), { currentMonth: currentMonth + 1, isSelected: (0, utils_1.checkActive)(daySelected, item.date), disabled: (0, utils_1.checkDisabled)({
                date: item.date,
                disabledDate: disabledDate,
                max: max,
                min: min
            }) })); });
        var calendars2 = (0, utils_1.createMonthCalendarWithAdjacentMonths)(currentYear, currentMonth + 1);
        var selectedCalendar2 = calendars2.map(function (item) { return (tslib_1.__assign(tslib_1.__assign({}, item), { currentMonth: currentMonth === 11 ? 1 : currentMonth + 2, isSelected: (0, utils_1.checkActive)(daySelected, item.date), disabled: (0, utils_1.checkDisabled)({
                date: item.date,
                disabledDate: disabledDate,
                max: max,
                min: min
            }) })); });
        var totalCalendar = tslib_1.__spreadArray(tslib_1.__spreadArray([], selectedCalendar, true), selectedCalendar2, true);
        setCalendar(totalCalendar);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [daySelected, currentMonth, currentYear]);
    var handleChangeMonth = function (type) {
        if (type === 'next') {
            if (currentMonth === 11) {
                setCurrentMonth(0);
                setCurrentYear(currentYear + 1);
            }
            else
                setCurrentMonth(currentMonth + 1);
        }
        else {
            if (currentMonth === 0) {
                setCurrentMonth(11);
                setCurrentYear(currentYear - 1);
            }
            else
                setCurrentMonth(currentMonth - 1);
        }
    };
    var _f = (0, react_1.useState)(null), startDate = _f[0], setStartDate = _f[1];
    var _g = (0, react_1.useState)(null), endDate = _g[0], setEndDate = _g[1];
    var _h = (0, react_1.useState)(null), hoveredDate = _h[0], setHoveredDate = _h[1];
    var _j = (0, react_1.useState)(null), endDateHoverNoParse = _j[0], setEndDateHoverNoParse = _j[1];
    var _k = (0, react_1.useState)(''), startDateWatch = _k[0], setStartDateWatch = _k[1];
    var _l = (0, react_1.useState)(''), endDateWatch = _l[0], setEndDateWatch = _l[1];
    var _m = (0, react_1.useState)(), startDateOld = _m[0], setStartDateOld = _m[1];
    var _o = (0, react_1.useState)(), endDateOld = _o[0], setEndDateOld = _o[1];
    var _p = (0, react_1.useState)(menuDay), menuSelectDay = _p[0], setMenuSelectDay = _p[1];
    (0, react_1.useEffect)(function () {
        if (defaultDate) {
            var currentDateParse = (0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date());
            setEndDate(currentDateParse);
            setStartDate((0, date_fns_1.subDays)(currentDateParse, defaultDate - 1));
            setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
            setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, defaultDate - 1), 'dd-MM-yyyy'));
        }
        else {
            var currentDateDefault = (0, utils_1.formatDate)(new Date());
            var currentDateParseDefault = (0, date_fns_1.parse)(currentDateDefault, 'dd-MM-yyyy', new Date());
            setEndDateWatch((0, date_fns_1.format)(currentDateParseDefault, 'dd-MM-yyyy'));
            setStartDateWatch((0, date_fns_1.format)(currentDateParseDefault, 'dd-MM-yyyy'));
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [defaultDate]);
    var handleSelectMenuDay = function (clickedItem) {
        var currentDateParse = (0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date());
        switch (clickedItem) {
            case 1:
                setStartDate(currentDateParse);
                setEndDate(currentDateParse);
                setStartDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                break;
            case 2:
                // Ngày hôm qua
                setStartDate((0, date_fns_1.subDays)(currentDateParse, 1));
                setEndDate((0, date_fns_1.subDays)(currentDateParse, 1));
                setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 1), 'dd-MM-yyyy'));
                setEndDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 1), 'dd-MM-yyyy'));
                break;
            case 3:
                // 7 ngày qua
                setEndDate(currentDateParse);
                setStartDate((0, date_fns_1.subDays)(currentDateParse, 6));
                setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 6), 'dd-MM-yyyy'));
                break;
            case 4:
                // 30 ngày qua
                setEndDate(currentDateParse);
                setStartDate((0, date_fns_1.subDays)(currentDateParse, 29));
                setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 29), 'dd-MM-yyyy'));
                break;
            case 5:
                // 90 ngày qua
                setEndDate(currentDateParse);
                setStartDate((0, date_fns_1.subDays)(currentDateParse, 89));
                setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 89), 'dd-MM-yyyy'));
                break;
            case 6:
                // 365 ngày qua
                setEndDate(currentDateParse);
                setStartDate((0, date_fns_1.subDays)(currentDateParse, 364));
                setEndDateWatch((0, date_fns_1.format)(currentDateParse, 'dd-MM-yyyy'));
                setStartDateWatch((0, date_fns_1.format)((0, date_fns_1.subDays)(currentDateParse, 364), 'dd-MM-yyyy'));
                break;
            default:
                break;
        }
        var updatedMenuSelectDay = menuSelectDay.map(function (item) {
            return item.id === clickedItem ? tslib_1.__assign(tslib_1.__assign({}, item), { active: true }) : tslib_1.__assign(tslib_1.__assign({}, item), { active: false });
        });
        setMenuSelectDay(updatedMenuSelectDay);
    };
    var checkAndSetMenuSelectDay = function (timeStart, timeEnd) {
        var currentDateParse = (0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date());
        var predefinedRanges = [
            { id: 1, start: currentDateParse, end: currentDateParse },
            {
                id: 2,
                start: (0, date_fns_1.subDays)(currentDateParse, 1),
                end: (0, date_fns_1.subDays)(currentDateParse, 1)
            },
            { id: 3, start: (0, date_fns_1.subDays)(currentDateParse, 6), end: currentDateParse },
            { id: 4, start: (0, date_fns_1.subDays)(currentDateParse, 29), end: currentDateParse },
            { id: 5, start: (0, date_fns_1.subDays)(currentDateParse, 89), end: currentDateParse },
            { id: 6, start: (0, date_fns_1.subDays)(currentDateParse, 364), end: currentDateParse },
        ];
        var startDateParsed = (0, date_fns_1.parse)(timeStart, 'dd-MM-yyyy', new Date());
        var endDateParsed = (0, date_fns_1.parse)(timeEnd, 'dd-MM-yyyy', new Date());
        var matchedItem = predefinedRanges.find(function (range) { return (0, date_fns_1.isEqual)(startDateParsed, range.start) && (0, date_fns_1.isEqual)(endDateParsed, range.end); });
        var updatedMenuSelectDay = menuSelectDay.map(function (item) {
            return item.id === (matchedItem === null || matchedItem === void 0 ? void 0 : matchedItem.id) ? tslib_1.__assign(tslib_1.__assign({}, item), { active: true }) : tslib_1.__assign(tslib_1.__assign({}, item), { active: false });
        });
        setMenuSelectDay(updatedMenuSelectDay);
    };
    var handleSelectDate = function (days) {
        var day = days.date;
        if (days.disabled) {
            return;
        }
        var selectedDay = (0, date_fns_1.parse)(day, 'dd-MM-yyyy', new Date());
        if (endDate.getTime() === startDate.getTime() && selectedDay.getTime() > startDate.getTime()) {
            setEndDate(selectedDay);
            setEndDateWatch(day);
        }
        else {
            setStartDate(selectedDay);
            setStartDateWatch(day);
            setEndDate(selectedDay);
            setEndDateWatch(day);
        }
    };
    (0, react_1.useEffect)(function () {
        if (endDateWatch && startDateWatch) {
            checkAndSetMenuSelectDay(startDateWatch, endDateWatch);
        }
    }, [endDateWatch, startDateWatch]);
    (0, react_1.useEffect)(function () {
        var updatedMenuSelectDay = menuDay.map(function (item) { return (item.id === 1 ? tslib_1.__assign(tslib_1.__assign({}, item), { active: true }) : item); });
        setMenuSelectDay(updatedMenuSelectDay);
        setStartDate((0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date()));
        setEndDate((0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date()));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var handleMouseOver = function (days) {
        var day = days.date;
        if (days.disabled) {
            return;
        }
        setHoveredDate((0, date_fns_1.parse)(day, 'dd-MM-yyyy', new Date()));
        setEndDateHoverNoParse(day);
    };
    (0, react_1.useEffect)(function () {
        var isValidStartDate = (0, utils_1.isValidDateFormat)(startDateWatch);
        if (!isValidStartDate) {
            return;
        }
        setStartDate((0, date_fns_1.parse)(startDateWatch, 'dd-MM-yyyy', new Date()));
        setStartDateOld(startDateWatch);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [startDateWatch]);
    (0, react_1.useEffect)(function () {
        var isValidEndDate = (0, utils_1.isValidDateFormat)(endDateWatch);
        if (!isValidEndDate) {
            return;
        }
        setEndDate((0, date_fns_1.parse)(endDateWatch, 'dd-MM-yyyy', new Date()));
        setEndDateOld(endDateWatch);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [endDateWatch]);
    var handleClickOutsite = function (type) {
        var isValidStartDate = (0, utils_1.isValidDateFormat)(startDateWatch);
        var isValidEndDate = (0, utils_1.isValidDateFormat)(endDateWatch);
        switch (type) {
            case 'start_date': {
                if (!isValidStartDate) {
                    setStartDateWatch(startDateOld);
                }
                return;
            }
            case 'end_date':
                if (!isValidEndDate) {
                    setEndDateWatch(endDateOld);
                }
                break;
            default:
                break;
        }
    };
    (0, react_1.useEffect)(function () {
        var currentDateParse = (0, date_fns_1.parse)(currentDate, 'dd-MM-yyyy', new Date());
        handleResult(currentDateParse, currentDateParse);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var handleSubmit = function () {
        handleResult(startDate, endDate);
    };
    var handleRemove = function () {
        handleCancel();
    };
    var handleSelectDay = function (event) {
        var selectedValue = event.target.value;
        var findValueSelectDay = menuSelectDay.find(function (item) { return item.content === selectedValue; });
        handleSelectMenuDay(findValueSelectDay.id);
    };
    return (react_1["default"].createElement("div", { className: ' max-w-[730px] rounded-lg border-[0.5px] border-gray-300 bg-white shadow-xl' },
        react_1["default"].createElement("div", { className: 'flex pr-4' },
            react_1["default"].createElement("div", { className: 'hidden w-48 p-1 text-sm lg:block' }, menuSelectDay.map(function (item) { return (react_1["default"].createElement("button", { key: item.id, className: "ml-1 mt-1 flex w-full items-center justify-between rounded-md px-3 py-1 text-start hover:cursor-pointer ".concat(item.active ? 'bg-gray-200 font-medium text-gray-900' : 'font-light text-gray-600 hover:bg-gray-100'), onClick: function () { return handleSelectMenuDay(item.id); }, type: 'button' },
                item.content,
                item.active ? react_1["default"].createElement(CheckIcon_1["default"], { className: 'h-4 w-4' }) : null)); })),
            react_1["default"].createElement("div", null,
                react_1["default"].createElement("div", { className: 'ml-2 block p-1 text-sm lg:hidden' },
                    react_1["default"].createElement(Select_1.PHXSelect, { onChange: handleSelectDay }, menuSelectDay.map(function (item) {
                        var _a;
                        return (react_1["default"].createElement("option", { key: item.id, selected: (_a = menuSelectDay.find(function (itemSelectDay) { return itemSelectDay.id === item.id; })) === null || _a === void 0 ? void 0 : _a.active }, item.content));
                    }))),
                react_1["default"].createElement("div", { className: 'ml-3 w-[calc(100vw-130px)] py-3 md:w-[504px]' },
                    react_1["default"].createElement("div", { className: 'mb-4 flex' },
                        react_1["default"].createElement(Input_1.PHXInput, { className: 'w-full', onBlur: function () { return handleClickOutsite('start_date'); }, onChange: function (e) { return setStartDateWatch(e.target.value); }, placeholder: 'DD-MM-YYYY', type: 'text', value: startDateWatch }),
                        react_1["default"].createElement(solid_1.ArrowRightIcon, { "aria-hidden": 'true', className: 'mx-3 my-auto h-5 w-10 text-gray-400' }),
                        react_1["default"].createElement(Input_1.PHXInput, { className: 'w-full', onBlur: function () { return handleClickOutsite('end_date'); }, onChange: function (e) { return setEndDateWatch(e.target.value); }, placeholder: 'DD-MM-YYYY', type: 'text', value: endDateWatch || '' })),
                    react_1["default"].createElement("div", { className: 'block lg:hidden' },
                        react_1["default"].createElement("div", { className: 'mx-auto flex w-full justify-between' },
                            react_1["default"].createElement("div", { className: 'flex w-full items-center text-gray-900' },
                                react_1["default"].createElement("button", { className: '-m-1.5 mr-12 flex flex-none items-center justify-center rounded-lg p-1 text-gray-500 hover:bg-gray-200', onClick: function () { return handleChangeMonth('prev'); }, type: 'button' },
                                    react_1["default"].createElement("span", { className: 'sr-only' }, "Previous month"),
                                    react_1["default"].createElement(solid_1.ArrowLeftIcon, { "aria-hidden": 'true', className: 'h-5 w-5' })),
                                react_1["default"].createElement("div", { className: 'flex-auto text-center text-xs font-medium' }, (0, utils_1.getMonthName)(currentMonth) + ' ' + currentYear),
                                react_1["default"].createElement("button", { className: '-m-1.5 ml-12 flex flex-none items-center justify-center rounded-lg p-1 text-gray-500 hover:bg-gray-200', onClick: function () { return handleChangeMonth('next'); }, type: 'button' },
                                    react_1["default"].createElement("span", { className: 'sr-only' }, "Next month"),
                                    react_1["default"].createElement(solid_1.ArrowRightIcon, { "aria-hidden": 'true', className: 'h-5 w-5' })))),
                        react_1["default"].createElement("div", { className: ' flex w-full ' }, [currentMonth + 1].map(function (month, idx) { return (react_1["default"].createElement("div", { key: idx, className: "w-full text-center lg:col-start-8 lg:col-end-13 lg:row-start-1 xl:col-start-9 ".concat(month === currentMonth + 1 ? 'mr-4' : '') },
                            react_1["default"].createElement("div", { className: 'mt-4 grid grid-cols-7 text-[0.75rem] text-xs font-normal text-gray-500' }, dayOfWeek.map(function (item, index) { return (react_1["default"].createElement("div", { key: index + 1, className: (0, utils_1.classNames)(checkToday(index === 7 ? 0 : index + 1, month) && '!font-semibold !text-gray-900') }, item)); })),
                            react_1["default"].createElement("div", { className: 'isolate mt-2 grid grid-cols-7 rounded-lg text-xs' }, calendar.map(function (day, index) {
                                if (day.currentMonth === month) {
                                    var selectedDay = (0, date_fns_1.parse)(day.date, 'dd-MM-yyyy', new Date());
                                    var hoveredDay = (0, date_fns_1.parse)(endDateHoverNoParse, 'dd-MM-yyyy', new Date());
                                    var isInRange = startDate && endDate && selectedDay > startDate && selectedDay < endDate;
                                    var isHovered = hoveredDate &&
                                        startDate &&
                                        !endDate &&
                                        selectedDay >= startDate &&
                                        selectedDay <= hoveredDate;
                                    var isHighlighted = startDate && endDate && selectedDay > startDate && selectedDay < endDate;
                                    var isSelectedStartDate = startDate && selectedDay.getTime() === startDate.getTime();
                                    var isSelectedEndDate = endDate && selectedDay.getTime() === endDate.getTime();
                                    var isStartNoRange = startDate && !endDate;
                                    var isSelectedStart = startDate && endDate && isSelectedStartDate;
                                    var isSelectedEnd = startDate && endDate && isSelectedEndDate;
                                    var isInRangeDynamicStart = selectedDay <= hoveredDate && isSelectedStartDate;
                                    var isInRangeDynamicEnd = startDate && isHovered && hoveredDay.getTime() === selectedDay.getTime();
                                    return (react_1["default"].createElement("button", { key: index, className: (0, utils_1.classNames)("cursor-pointer py-[0.425rem] text-[0.75rem] font-light text-gray-800  hover:text-white focus:z-10", day.isCurrentMonth ? 'bg-white' : 'text-gray-300', day.isCurrentMonth ? 'bg-white' : 'text-gray-300', day.disabled ? '' : 'hover:rounded-lg hover:!bg-gray-900', day.isToday ? 'font-semibold text-gray-900' : 'font-normal', day.disabled && day.isCurrentMonth
                                            ? '!cursor-default !text-gray-300 hover:!bg-transparent hover:!text-gray-300'
                                            : '', !day.isToday &&
                                            day.isCurrentMonth &&
                                            !day.isSelected &&
                                            !day.disabled &&
                                            'text-gray-700', isSelectedStartDate && !day.disabled ? 'rounded-l-lg !bg-gray-800 text-white' : '', isSelectedEndDate && 'rounded-r-lg !bg-gray-800 text-white', isHovered && '!rounded-none !bg-gray-200', day.isSelected && '!bg-gray-800 text-white', isHighlighted && 'rounded-none !bg-gray-200', !day.isCurrentMonth && 'hidden', isStartNoRange && 'rounded-lg', isInRange && 'hover:rounded-none', isSelectedStart && 'hover:rounded-r-none', isSelectedEnd && 'hover:rounded-l-none', isInRangeDynamicStart && '!rounded-l-lg', isInRangeDynamicEnd && '!rounded-r-lg'), onClick: function () { return handleSelectDate(day); }, onMouseOver: function () { return handleMouseOver(day); }, style: {
                                            gridColumn: day.dayOfWeek === 0 ? 7 : day.dayOfWeek
                                        }, type: 'button' },
                                        react_1["default"].createElement("time", { className: '', dateTime: day.date }, day.date.split('-')[0].replace(/^0/, ''))));
                                }
                                return null;
                            })))); }))),
                    react_1["default"].createElement("div", { className: 'hidden lg:block' },
                        react_1["default"].createElement("div", { className: 'mx-auto flex w-full justify-between' },
                            react_1["default"].createElement("div", { className: 'flex items-center text-gray-900' },
                                react_1["default"].createElement("button", { className: '-m-1.5 mr-12 flex flex-none items-center justify-center rounded-lg p-1 text-gray-500 hover:bg-gray-200', onClick: function () { return handleChangeMonth('prev'); }, type: 'button' },
                                    react_1["default"].createElement("span", { className: 'sr-only' }, "Previous month"),
                                    react_1["default"].createElement(solid_1.ArrowLeftIcon, { "aria-hidden": 'true', className: 'h-5 w-5' })),
                                react_1["default"].createElement("div", { className: 'flex-auto text-xs font-medium' }, (0, utils_1.getMonthName)(currentMonth) + ' ' + currentYear)),
                            react_1["default"].createElement("div", { className: 'flex items-center text-gray-900' },
                                react_1["default"].createElement("div", { className: 'flex-auto text-xs font-medium' }, currentMonth === 11
                                    ? "Th\u00E1ng 1 ".concat(currentYear + 1)
                                    : (0, utils_1.getMonthName)(currentMonth + 1) + ' ' + currentYear),
                                react_1["default"].createElement("button", { className: '-m-1.5 ml-12 flex flex-none items-center justify-center rounded-lg p-1 text-gray-500 hover:bg-gray-200', onClick: function () { return handleChangeMonth('next'); }, type: 'button' },
                                    react_1["default"].createElement("span", { className: 'sr-only' }, "Next month"),
                                    react_1["default"].createElement(solid_1.ArrowRightIcon, { "aria-hidden": 'true', className: 'h-5 w-5' })))),
                        react_1["default"].createElement("div", { className: 'flex  w-full ' }, [currentMonth + 1, currentMonth === 11 ? 1 : currentMonth + 2].map(function (month, idx) { return (react_1["default"].createElement("div", { key: idx, className: "w-full text-center lg:col-start-8 lg:col-end-13 lg:row-start-1 xl:col-start-9 ".concat(month === currentMonth + 1 ? 'mr-4' : '') },
                            react_1["default"].createElement("div", { className: 'mt-4 grid grid-cols-7 text-[0.75rem] text-xs font-normal text-gray-500' }, dayOfWeek.map(function (item, index) { return (react_1["default"].createElement("div", { key: index + 1, className: (0, utils_1.classNames)(checkToday(index === 7 ? 0 : index + 1, month) && '!font-semibold !text-gray-900') }, item)); })),
                            react_1["default"].createElement("div", { className: 'isolate mt-2 grid grid-cols-7 rounded-lg text-xs' }, calendar.map(function (day, index) {
                                if (day.currentMonth === month) {
                                    var selectedDay = (0, date_fns_1.parse)(day.date, 'dd-MM-yyyy', new Date());
                                    var hoveredDay = (0, date_fns_1.parse)(endDateHoverNoParse, 'dd-MM-yyyy', new Date());
                                    var isInRange = startDate && endDate && selectedDay > startDate && selectedDay < endDate;
                                    var isHovered = hoveredDate &&
                                        startDate &&
                                        !endDate &&
                                        selectedDay >= startDate &&
                                        selectedDay <= hoveredDate;
                                    var isHighlighted = startDate && endDate && selectedDay > startDate && selectedDay < endDate;
                                    var isSelectedStartDate = startDate && selectedDay.getTime() === startDate.getTime();
                                    var isSelectedEndDate = endDate && selectedDay.getTime() === endDate.getTime();
                                    var isStartNoRange = startDate && !endDate;
                                    var isSelectedStart = startDate && endDate && isSelectedStartDate;
                                    var isSelectedEnd = startDate && endDate && isSelectedEndDate;
                                    var isInRangeDynamicStart = selectedDay <= hoveredDate && isSelectedStartDate;
                                    var isInRangeDynamicEnd = startDate && isHovered && hoveredDay.getTime() === selectedDay.getTime();
                                    return (react_1["default"].createElement("button", { key: index, className: (0, utils_1.classNames)("cursor-pointer py-[0.425rem] text-[0.75rem] font-light text-gray-800  hover:text-white focus:z-10", day.isCurrentMonth ? 'bg-white' : 'text-gray-300', day.isCurrentMonth ? 'bg-white' : 'text-gray-300', day.disabled ? '' : 'hover:rounded-lg hover:!bg-gray-900', day.isToday ? 'font-semibold text-gray-900' : 'font-normal', day.disabled && day.isCurrentMonth
                                            ? '!cursor-default !text-gray-300 hover:!bg-transparent hover:!text-gray-300'
                                            : '', !day.isToday &&
                                            day.isCurrentMonth &&
                                            !day.isSelected &&
                                            !day.disabled &&
                                            'text-gray-700', isSelectedStartDate && !day.disabled ? 'rounded-l-lg !bg-gray-800 text-white' : '', isSelectedEndDate && 'rounded-r-lg !bg-gray-800 text-white', isHovered && '!rounded-none !bg-gray-200', day.isSelected && '!bg-gray-800 text-white', isHighlighted && 'rounded-none !bg-gray-200', !day.isCurrentMonth && 'hidden', isStartNoRange && 'rounded-lg', isInRange && 'hover:rounded-none', isSelectedStart && 'hover:rounded-r-none', isSelectedEnd && 'hover:rounded-l-none', isInRangeDynamicStart && '!rounded-l-lg', isInRangeDynamicEnd && '!rounded-r-lg'), onClick: function () { return handleSelectDate(day); }, onMouseOver: function () { return handleMouseOver(day); }, style: {
                                            gridColumn: day.dayOfWeek === 0 ? 7 : day.dayOfWeek
                                        }, type: 'button' },
                                        react_1["default"].createElement("time", { className: '', dateTime: day.date }, day.date.split('-')[0].replace(/^0/, ''))));
                                }
                                return null;
                            })))); })))))),
        react_1["default"].createElement("div", { className: 'flex justify-end border-t py-4 pr-4' },
            react_1["default"].createElement(Button_1.PHXButton, { onClick: handleRemove, secondary: true, size: 'micro' }, "Hu\u1EF7"),
            react_1["default"].createElement(Button_1.PHXButton, { className: 'ml-2', onClick: handleSubmit, primary: true, size: 'micro' }, "X\u00E1c nh\u1EADn"))));
}
exports["default"] = Calendar;
//# sourceMappingURL=Calendar.js.map