"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var read_env_config_1 = require("../../read-env-config");
var axios_1 = tslib_1.__importDefault(require("axios"));
var js_cookie_1 = tslib_1.__importDefault(require("js-cookie"));
var constants_1 = require("../../utils/constants");
function PHXClientQueryDataCenterV3(_a) {
    var query = _a.query, variables = _a.variables, _b = _a.isDelay, isDelay = _b === void 0 ? true : _b;
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var startTime, queryResult, urlApiGateway, authTokenInfo, error_1, endTime, duration;
        return tslib_1.__generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    startTime = performance.now();
                    urlApiGateway = (0, read_env_config_1.getEnv)('NEXT_PUBLIC_API_GATEWAY', process.env.NEXT_PUBLIC_API_GATEWAY);
                    authTokenInfo = js_cookie_1["default"].get(constants_1.AUTH_TOKEN) && JSON.parse(js_cookie_1["default"].get(constants_1.AUTH_TOKEN));
                    _c.label = 1;
                case 1:
                    _c.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, axios_1["default"].post("".concat(urlApiGateway, "/query"), {
                            source: 'dashboard',
                            query: query,
                            variables: variables,
                            headers: {
                                hostname: 'data-center'
                            }
                        }, {
                            headers: {
                                'Content-Type': 'application/json',
                                Authorization: 'Bearer' + ' ' + authTokenInfo.token
                            }
                        })];
                case 2:
                    queryResult = _c.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _c.sent();
                    throw new Error('Error with Axios request: ' + error_1.message);
                case 4:
                    endTime = performance.now();
                    duration = endTime - startTime;
                    if (!(duration < constants_1.requestMaxDuration && isDelay)) return [3 /*break*/, 6];
                    console.info('promise delay...');
                    return [4 /*yield*/, new Promise(function (r) { return setTimeout(r, 100); })];
                case 5:
                    _c.sent();
                    _c.label = 6;
                case 6: return [2 /*return*/, queryResult];
            }
        });
    });
}
exports["default"] = PHXClientQueryDataCenterV3;
//# sourceMappingURL=clientQueryDataCenterV3.js.map