"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var js_cookie_1 = tslib_1.__importDefault(require("js-cookie"));
var constants_1 = require("../../utils/constants");
var client_1 = require("@apollo/client");
var read_env_config_1 = require("../../read-env-config");
function PHXGetHttpLinkConfig() {
    var env = (0, read_env_config_1.getEnv)('NEXT_PUBLIC_ENV', process.env.NEXT_PUBLIC_ENV);
    var publicAPI = (0, read_env_config_1.getEnv)('NEXT_PUBLIC_API', process.env.NEXT_PUBLIC_API);
    var uri = "".concat(publicAPI, "/graphql/rd/v1/graphql");
    if (env === 'local') {
        uri = publicAPI;
    }
    var authTokenInfo = js_cookie_1["default"].get(constants_1.AUTH_TOKEN) && JSON.parse(js_cookie_1["default"].get(constants_1.AUTH_TOKEN));
    var httpLink = new client_1.HttpLink({
        uri: uri
    });
    console.log('httpLink in table', httpLink);
    if (js_cookie_1["default"].get(constants_1.AUTH_TOKEN)) {
        httpLink = new client_1.HttpLink({
            uri: uri,
            headers: {
                Authorization: 'Bearer' + ' ' + authTokenInfo.token,
                'authorization-id': authTokenInfo.userId
            }
        });
    }
    return httpLink;
}
exports["default"] = PHXGetHttpLinkConfig;
//# sourceMappingURL=getHttpLinkConfig.js.map