"use strict";
exports.__esModule = true;
exports.PHXLogUserActivity = void 0;
var tslib_1 = require("tslib");
var client_1 = require("@apollo/client");
var mutation_1 = require("../../query/userActivity/mutation");
var read_env_config_1 = require("../../read-env-config");
var js_cookie_1 = tslib_1.__importDefault(require("js-cookie"));
var constants_1 = require("../../utils/constants");
var getLoginInfo_1 = tslib_1.__importDefault(require("./getLoginInfo"));
function generatePayload(data, user_id, school_id) {
    return tslib_1.__assign(tslib_1.__assign({}, data), { school_id: school_id, user_id: user_id });
}
var PHXLogUserActivity = function (data) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
    var uri, authTokenInfo, schoolInfo, userId, schoolId, payload, client, res, err_1;
    return tslib_1.__generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                uri = (0, read_env_config_1.getEnv)('NEXT_PUBLIC_API', process.env.NEXT_PUBLIC_API);
                authTokenInfo = js_cookie_1["default"].get(constants_1.AUTH_TOKEN) && JSON.parse(js_cookie_1["default"].get(constants_1.AUTH_TOKEN));
                schoolInfo = (0, getLoginInfo_1["default"])();
                userId = schoolInfo.id;
                schoolId = schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id;
                payload = generatePayload(data, userId, schoolId);
                client = new client_1.ApolloClient({
                    uri: uri,
                    cache: new client_1.InMemoryCache(),
                    headers: {
                        Authorization: 'Bearer' + ' ' + authTokenInfo.token,
                        'Content-Type': 'application/json'
                    }
                });
                return [4 /*yield*/, client.mutate({
                        mutation: mutation_1.INSERT_USER_ACTIVITY_MUTATION,
                        variables: payload
                    })];
            case 1:
                res = _a.sent();
                return [2 /*return*/, res];
            case 2:
                err_1 = _a.sent();
                console.log(err_1);
                return [2 /*return*/, []];
            case 3: return [2 /*return*/];
        }
    });
}); };
exports.PHXLogUserActivity = PHXLogUserActivity;
//# sourceMappingURL=logUserActivity.js.map