"use strict";
'use client';
exports.__esModule = true;
exports.PBFMainWrap = exports.CODE_NGANH_STONE = exports.CODE_NGANH_INTER_LEVEL = exports.CODE_NGANH_UNI = exports.AUTH_TOKEN = exports.isLoggedCookie = void 0;
var tslib_1 = require("tslib");
var client_1 = require("@apollo/client");
var free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
var react_fontawesome_1 = require("@fortawesome/react-fontawesome");
var react_1 = require("@headlessui/react");
var solid_1 = require("@heroicons/react/20/solid");
var solid_2 = require("@heroicons/react/24/solid");
var link_1 = tslib_1.__importDefault(require("next/link"));
var react_2 = tslib_1.__importStar(require("react"));
var types_1 = require("../types");
var read_env_config_1 = require("../../read-env-config");
var ToolTip_1 = tslib_1.__importDefault(require("../ToolTip/ToolTip"));
exports.isLoggedCookie = 'isLoggedIn';
exports.AUTH_TOKEN = 'authToken';
exports.CODE_NGANH_UNI = 'UNI';
exports.CODE_NGANH_INTER_LEVEL = 'INTER_LEVEL_SCHOOL';
exports.CODE_NGANH_STONE = 'STONE';
function PBFMainWrap(_a) {
    var _this = this;
    var children = _a.children, pathName = _a.pathName;
    var _b = (0, react_2.useState)(false), sidebarOpen = _b[0], setSidebarOpen = _b[1];
    var _c = (0, react_2.useState)([]), menu = _c[0], setMenu = _c[1];
    var _d = (0, react_2.useState)(null), userId = _d[0], setUserId = _d[1];
    var _e = (0, react_2.useState)(null), codeNganh = _e[0], setCodeNganh = _e[1];
    var _f = (0, react_2.useState)(null), token = _f[0], setToken = _f[1];
    var _g = (0, react_2.useState)(false), isTokenLoaded = _g[0], setIsTokenLoaded = _g[1];
    (0, react_2.useEffect)(function () {
        var _a, _b, _c;
        if (typeof window !== 'undefined') {
            var dataLoggedLocal = localStorage.getItem(exports.isLoggedCookie);
            setUserId(dataLoggedLocal ? (_a = JSON.parse(dataLoggedLocal)) === null || _a === void 0 ? void 0 : _a.id : '0');
            setToken(localStorage.getItem(exports.AUTH_TOKEN));
            setCodeNganh(dataLoggedLocal ? (_c = (_b = JSON.parse(dataLoggedLocal)) === null || _b === void 0 ? void 0 : _b.nganh) === null || _c === void 0 ? void 0 : _c.code : exports.CODE_NGANH_STONE);
            setIsTokenLoaded(true);
        }
    }, []);
    var requireLoginValidation = function () {
        var _a;
        if (typeof window !== 'undefined') {
            var currentURL = (_a = window === null || window === void 0 ? void 0 : window.location) === null || _a === void 0 ? void 0 : _a.href;
            var url = currentURL.split('/');
            var loginPush = "".concat(url[0], "//").concat(url[2], "/login");
            window.sessionStorage.setItem('urlAppOrRe', currentURL);
            window.location.replace(loginPush);
        }
    };
    var getUserPermissionInfo = (0, client_1.gql)(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject(["\n    query MyQuery($userId: Int) {\n      user(where: { id: { _eq: $userId }, deleted_at: { _is_null: true } }) {\n        id\n        user_code\n        full_name\n        gender\n        company_id\n        department_id\n        position_id\n        company {\n          code\n          name\n        }\n        department {\n          code\n          name\n        }\n        user_roles(where: { is_active: { _eq: true } }) {\n          role {\n            role_code\n            name\n            permission_roles(where: { is_active: { _eq: true } }) {\n              is_active\n              permission_id\n              permission {\n                code\n                name\n                level\n              }\n            }\n          }\n          is_active\n        }\n        position {\n          code\n          name\n        }\n        permission_users {\n          is_active\n          permission_id\n          company_id\n          permission {\n            code\n            level\n            name\n          }\n        }\n      }\n    }\n  "], ["\n    query MyQuery($userId: Int) {\n      user(where: { id: { _eq: $userId }, deleted_at: { _is_null: true } }) {\n        id\n        user_code\n        full_name\n        gender\n        company_id\n        department_id\n        position_id\n        company {\n          code\n          name\n        }\n        department {\n          code\n          name\n        }\n        user_roles(where: { is_active: { _eq: true } }) {\n          role {\n            role_code\n            name\n            permission_roles(where: { is_active: { _eq: true } }) {\n              is_active\n              permission_id\n              permission {\n                code\n                name\n                level\n              }\n            }\n          }\n          is_active\n        }\n        position {\n          code\n          name\n        }\n        permission_users {\n          is_active\n          permission_id\n          company_id\n          permission {\n            code\n            level\n            name\n          }\n        }\n      }\n    }\n  "])));
    var userPermissionData = (0, client_1.useQuery)(getUserPermissionInfo, {
        variables: { userId: userId },
        fetchPolicy: 'network-only'
    }).data;
    // console.log('userPermissionData', userPermissionData);
    var _h = (userPermissionData === null || userPermissionData === void 0 ? void 0 : userPermissionData.user[0]) || {}, full_name = _h.full_name, permission_users = _h.permission_users, user_roles = _h.user_roles;
    // console.log('permission_users', permission_users);
    // danh sách role
    var listRoleCode = user_roles === null || user_roles === void 0 ? void 0 : user_roles.map(function (item) {
        var _a;
        // console.log('role...', item.role);
        var listPermission = (_a = item.role.permission_roles) === null || _a === void 0 ? void 0 : _a.map(function (permission) {
            // console.log('permission', permission);
            return permission.is_active ? permission.permission : {};
        });
        return item.is_active
            ? {
                roleCode: item.role.role_code,
                listPermission: listPermission
            }
            : {};
    });
    // console.log('listRoleCode', listRoleCode);
    // gộp danh sách quyền từ role và quyền cá nhân
    var mergeListPermissionCode = function () {
        var _a;
        // list quyền được cấp riêng
        var listPermissionCodePersional = (permission_users === null || permission_users === void 0 ? void 0 : permission_users.map(function (item) { return item.permission.code; })) || [];
        // console.log('listRoleCodePersional', listPermissionCodePersional);
        // Danh sách các mã quyền của user
        var listPermissionCodeByRole = ((_a = listRoleCode === null || listRoleCode === void 0 ? void 0 : listRoleCode.map(function (item) {
            var _a;
            var permissionCode = (_a = item.listPermission) === null || _a === void 0 ? void 0 : _a.map(function (per) { return per.code; });
            return permissionCode;
        })) === null || _a === void 0 ? void 0 : _a.flat()) || []; // convert mảng permission
        // console.log('listPermissionCode', listPermissionCodeByRole);
        // gộp danh sách quyền từ role và quyền cá nhân
        var listPermissionCode = tslib_1.__spreadArray(tslib_1.__spreadArray([], listPermissionCodeByRole, true), listPermissionCodePersional, true);
        // console.log('listPermissionCode', listPermissionCode);
        return listPermissionCode;
    };
    var isSuperAdmin = listRoleCode === null || listRoleCode === void 0 ? void 0 : listRoleCode.some(function (item) { return item.roleCode === 'SUPER_ADMIN'; });
    // console.log('isSuperAdmin', isSuperAdmin);
    var getEnvMenu = function () {
        switch (codeNganh) {
            case exports.CODE_NGANH_UNI:
                return (0, read_env_config_1.getEnv)('NEXT_PUBLIC_ENV_PBF_MENU_UNI', process.env.NEXT_PUBLIC_ENV_PBF_MENU_UNI);
            case exports.CODE_NGANH_INTER_LEVEL:
                return (0, read_env_config_1.getEnv)('NEXT_PUBLIC_ENV_PBF_MENU_INTER_LEVEL', process.env.NEXT_PUBLIC_ENV_PBF_MENU_INTER_LEVEL);
            default:
                return (0, read_env_config_1.getEnv)('NEXT_PUBLIC_ENV_PBF_MENU', process.env.NEXT_PUBLIC_ENV_PBF_MENU);
        }
    };
    var publicEnvPbfMenu = getEnvMenu();
    var phenikaaLogo = (0, read_env_config_1.getEnv)('NEXT_PUBLIC_ENV_PBF_LOGO', process.env.NEXT_PUBLIC_ENV_PBF_LOGO);
    (0, react_2.useEffect)(function () {
        // Lấy token từ localStorage
        if (!token && isTokenLoaded) {
            requireLoginValidation();
        }
    }, [token, isTokenLoaded]);
    var fetchDataMenu = function (url) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var data, jsonMenu, listPermissionCode, permissionMenu;
        var _a;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, fetch(url, {
                        headers: {
                            'Content-Type': 'application/json'
                        }
                    })];
                case 1:
                    data = _b.sent();
                    return [4 /*yield*/, data.json()
                        // nếu là super admin lấy toàn bộ menu
                    ];
                case 2:
                    jsonMenu = _b.sent();
                    // nếu là super admin lấy toàn bộ menu
                    if (isSuperAdmin) {
                        setMenu(jsonMenu);
                        return [2 /*return*/];
                    }
                    listPermissionCode = mergeListPermissionCode() // danh sách tất cả các quyền
                    ;
                    permissionMenu = (_a = jsonMenu === null || jsonMenu === void 0 ? void 0 : jsonMenu.map(function (item) {
                        var _a;
                        var subMenu = (_a = item.children) === null || _a === void 0 ? void 0 : _a.filter(function (child) { return listPermissionCode === null || listPermissionCode === void 0 ? void 0 : listPermissionCode.includes(child.code); });
                        return tslib_1.__assign(tslib_1.__assign({}, item), { children: subMenu });
                    }) // lấy ra các menu con có quyền
                    ) === null || _a === void 0 ? void 0 : _a.filter(function (x) { var _a; return (listPermissionCode === null || listPermissionCode === void 0 ? void 0 : listPermissionCode.includes(x === null || x === void 0 ? void 0 : x.code)) && ((_a = x.children) === null || _a === void 0 ? void 0 : _a.length) > 0; }) // filter menu cha ko có menu con nào có quyền
                    ;
                    // console.log('permissionMenu', permissionMenu);
                    setMenu(permissionMenu || []);
                    return [2 /*return*/];
            }
        });
    }); };
    (0, react_2.useEffect)(function () {
        // Let load left menu data
        if (!publicEnvPbfMenu) {
            console.error('menu not found');
            return;
        }
        if (!userPermissionData)
            return;
        fetchDataMenu(publicEnvPbfMenu)["catch"](function (error) { return console.error(error); });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [userPermissionData]);
    var _j = (0, react_2.useState)(true), isOpen = _j[0], setIsOpen = _j[1];
    var openNav = function () {
        setIsOpen(true);
    };
    var closeNav = function () {
        setIsOpen(false);
    };
    var handelLogout = function () {
        localStorage.removeItem(exports.AUTH_TOKEN);
        localStorage.removeItem(exports.isLoggedCookie);
        requireLoginValidation();
    };
    var renderNavigation = function () { return (react_2["default"].createElement("nav", { className: 'flex flex-1 flex-col' },
        react_2["default"].createElement("ul", { className: 'flex flex-1 flex-col gap-y-7', role: 'list' },
            react_2["default"].createElement("li", null,
                react_2["default"].createElement("ul", { className: '-mx-2 space-y-1', role: 'list' }, menu.map(function (item) {
                    var _a;
                    return (react_2["default"].createElement("li", { key: item.name, className: 'cursor-pointer' }, !item.children ? (react_2["default"].createElement("a", { className: (0, types_1.classNames)(item.href === pathName ? 'bg-white ' : 'hover:bg-white hover:bg-opacity-50 ', 'group flex items-center gap-x-3 rounded-md p-1 text-[0.84rem] font-medium leading-6 text-[#374151]'), href: item.href },
                        react_2["default"].createElement("span", { className: 'font-medium leading-5 text-[#374151]', dangerouslySetInnerHTML: {
                                __html: item.icon
                            } }),
                        isOpen ? item.name : '')) : (react_2["default"].createElement(react_1.Disclosure, { as: 'div', defaultOpen: (_a = item.children) === null || _a === void 0 ? void 0 : _a.some(function (child) { var _a; return (_a = child.listPath) === null || _a === void 0 ? void 0 : _a.some(function (path) { return pathName === null || pathName === void 0 ? void 0 : pathName.includes(path); }); }) }, function (_a) {
                        var _b, _c;
                        var open = _a.open;
                        return (react_2["default"].createElement(react_2["default"].Fragment, null,
                            react_2["default"].createElement("a", { className: (0, types_1.classNames)(((_b = item.children) === null || _b === void 0 ? void 0 : _b.some(function (child) { var _a; return (_a = child.listPath) === null || _a === void 0 ? void 0 : _a.some(function (path) { return pathName === null || pathName === void 0 ? void 0 : pathName.includes(path); }); }))
                                    ? '' /* `${
                                        !isOpen ? 'bg-white' : 'hover:bg-white hover:bg-opacity-50 '
                                      }` */
                                    : 'hover:bg-white hover:bg-opacity-50 ', 'flex w-full items-center gap-x-3 rounded-md p-1 text-left text-[0.84rem] font-medium leading-6 text-[#374151] transition-all duration-100'), href: item.href },
                                react_2["default"].createElement("span", { className: 'h-5 w-5 shrink-0 overflow-hidden', dangerouslySetInnerHTML: {
                                        __html: item.icon
                                    } }),
                                isOpen && (react_2["default"].createElement(react_2["default"].Fragment, null,
                                    react_2["default"].createElement("p", { className: 'truncate' }, item.name),
                                    react_2["default"].createElement(solid_1.ChevronRightIcon, { "aria-hidden": 'true', className: (0, types_1.classNames)(open ? 'rotate-90' : '', 'ml-auto h-4 w-4 shrink-0') })))),
                            react_2["default"].createElement("style", null, "\n                            .content-tool-tip p {\n                              word-break: break-word\n                            }\n                            "),
                            ((_c = item.children) === null || _c === void 0 ? void 0 : _c.some(function (child) { var _a; return (_a = child.listPath) === null || _a === void 0 ? void 0 : _a.some(function (path) { return pathName === null || pathName === void 0 ? void 0 : pathName.includes(path); }); })) &&
                                isOpen && (react_2["default"].createElement(react_1.Disclosure.Panel, { as: 'ul', className: 'mt-1 px-2' }, item.children.map(function (subItem, subItemIndex) {
                                var _a;
                                return (react_2["default"].createElement(ToolTip_1["default"], { content: subItem.name, className: 'w-full', contentClassName: 'content-tool-tip whitespace-normal' },
                                    react_2["default"].createElement("li", { key: subItem.name },
                                        react_2["default"].createElement(link_1["default"], { className: (0, types_1.classNames)(((_a = subItem.listPath) === null || _a === void 0 ? void 0 : _a.some(function (path) { return pathName === null || pathName === void 0 ? void 0 : pathName.includes(path); }))
                                                ? 'bg-white'
                                                : 'hover:bg-white hover:bg-opacity-50 ', subItemIndex !== 0 && 'mt-1', 'block truncate rounded-md py-1 pl-9 pr-2 text-xs leading-6 text-[#374151]'), href: subItem.href }, subItem.name))));
                            })))));
                    }))));
                }))),
            react_2["default"].createElement("li", { className: '-mx-6 mt-auto hidden lg:block' },
                react_2["default"].createElement("div", { className: "flex items-center gap-x-4 px-6 py-3 text-[0.84rem] font-medium leading-6 text-[#374151]  ".concat(!isOpen && '-mx-4 justify-center') },
                    react_2["default"].createElement(react_1.Menu, { as: 'div', className: 'relative inline-block text-left' },
                        react_2["default"].createElement("div", null,
                            react_2["default"].createElement(react_1.Menu.Button, { className: '\n                  flex items-center gap-3' },
                                react_2["default"].createElement("div", { "aria-hidden": 'true', className: 'rounded-full bg-gray-100 text-gray-600 hover:text-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 focus:ring-offset-gray-100' },
                                    react_2["default"].createElement("img", { alt: '', className: "h-8 w-8 rounded-full bg-[#ebebeb] ".concat(!isOpen && '-mx-4'), src: 'https://i1.sndcdn.com/avatars-000518557020-ib8qs8-t500x500.jpg' })),
                                react_2["default"].createElement("div", { "aria-hidden": 'true', className: "truncate ".concat(!isOpen && 'hidden', " cursor-pointer hover:underline") }, full_name))),
                        react_2["default"].createElement(react_1.Transition, { as: react_2.Fragment, enter: 'transition ease-out duration-100', enterFrom: 'transform opacity-0 scale-95', enterTo: 'transform opacity-100 scale-100', leave: 'transition ease-in duration-75', leaveFrom: 'transform opacity-100 scale-100', leaveTo: 'transform opacity-0 scale-95' },
                            react_2["default"].createElement(react_1.Menu.Items, { className: 'absolute bottom-[40px] left-3 z-10 mt-1.5 max-h-96 w-[200px] min-w-[7.2rem] origin-top-right overflow-y-auto whitespace-nowrap rounded-lg bg-white shadow-[0rem_0.25rem_0.375rem_-0.125rem_rgba(26,26,26,.2)] focus:outline-none' },
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'flex items-center justify-between border-b border-gray-200 p-2' },
                                        react_2["default"].createElement("p", null, "C\u00E0i \u0111\u1EB7t"),
                                        ' ')),
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'cursor-pointer p-2 text-xs hover:bg-gray-100' }, "Th\u00F4ng tin c\u00E1 nh\u00E2n")),
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'cursor-pointer p-2 text-xs hover:bg-gray-100', onClick: handelLogout }, "\u0110\u0103ng xu\u1EA5t")))))))))); };
    return (react_2["default"].createElement(react_2["default"].Fragment, null,
        react_2["default"].createElement("div", { className: 'h-screen overflow-y-auto bg-[#f1f1f1]' },
            react_2["default"].createElement(react_1.Transition.Root, { as: react_2.Fragment, show: sidebarOpen },
                react_2["default"].createElement(react_1.Dialog, { as: 'div', className: 'relative z-50 lg:hidden', onClose: setSidebarOpen },
                    react_2["default"].createElement(react_1.Transition.Child, { as: react_2.Fragment, enter: 'transition-opacity ease-linear duration-300', enterFrom: 'opacity-0', enterTo: 'opacity-100', leave: 'transition-opacity ease-linear duration-300', leaveFrom: 'opacity-100', leaveTo: 'opacity-0' },
                        react_2["default"].createElement("div", { className: 'fixed inset-0 bg-gray-900/80' })),
                    react_2["default"].createElement("div", { className: 'fixed inset-0 flex' },
                        react_2["default"].createElement(react_1.Transition.Child, { as: react_2.Fragment, enter: 'transition ease-in-out duration-300 transform', enterFrom: '-translate-x-full', enterTo: 'translate-x-0', leave: 'transition ease-in-out duration-300 transform', leaveFrom: 'translate-x-0', leaveTo: '-translate-x-full' },
                            react_2["default"].createElement(react_1.Dialog.Panel, { className: 'relative mr-16 flex w-full max-w-[15rem] flex-1' },
                                react_2["default"].createElement(react_1.Transition.Child, { as: react_2.Fragment, enter: 'ease-in-out duration-300', enterFrom: 'opacity-0', enterTo: 'opacity-100', leave: 'ease-in-out duration-300', leaveFrom: 'opacity-100', leaveTo: 'opacity-0' },
                                    react_2["default"].createElement("div", { className: 'absolute left-full top-0 flex w-16 justify-center pt-5' },
                                        react_2["default"].createElement("button", { className: '-m-2.5 p-2.5', onClick: function () { return setSidebarOpen(false); }, type: 'button' },
                                            react_2["default"].createElement("span", { className: 'sr-only' }, "Close sidebar"),
                                            react_2["default"].createElement(solid_2.XMarkIcon, { "aria-hidden": 'true', className: 'h-6 w-6 text-[#374151]' })))),
                                react_2["default"].createElement("div", { className: 'flex grow flex-col gap-0 overflow-y-auto bg-[#ebebeb] px-6 pb-2' },
                                    react_2["default"].createElement("a", { className: 'flex h-16 shrink-0 items-center', href: '/dashboard' },
                                        react_2["default"].createElement("img", { alt: 'Your Company', className: 'h-[2rem] w-auto', src: phenikaaLogo })),
                                    renderNavigation())))))),
            react_2["default"].createElement("div", { className: 'sticky top-0 z-40 flex items-center justify-between gap-x-6 bg-[#ebebeb] px-4 py-4 shadow-sm sm:px-6 lg:hidden' },
                react_2["default"].createElement("button", { className: '-m-2.5 p-2.5 text-[#374151] lg:hidden', onClick: function () { return setSidebarOpen(true); }, type: 'button' },
                    react_2["default"].createElement(solid_2.Bars3Icon, { "aria-hidden": 'true', className: 'h-6 w-6' })),
                react_2["default"].createElement("div", null,
                    react_2["default"].createElement(react_1.Menu, { as: 'div', className: 'relative inline-block text-left' },
                        react_2["default"].createElement("div", null,
                            react_2["default"].createElement(react_1.Menu.Button, { className: '\n              flex items-center rounded-full bg-gray-100 text-gray-600 hover:text-gray-900 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 focus:ring-offset-gray-100' },
                                react_2["default"].createElement("div", { className: 'flex items-center gap-x-1 text-gray-900' },
                                    react_2["default"].createElement("img", { alt: '', className: "h-8 w-8 rounded-full bg-[#ebebeb] ".concat(!isOpen && '-mx-4'), src: 'https://i1.sndcdn.com/avatars-000518557020-ib8qs8-t500x500.jpg' })))),
                        react_2["default"].createElement(react_1.Transition, { as: react_2.Fragment, enter: 'transition ease-out duration-100', enterFrom: 'transform opacity-0 scale-95', enterTo: 'transform opacity-100 scale-100', leave: 'transition ease-in duration-75', leaveFrom: 'transform opacity-100 scale-100', leaveTo: 'transform opacity-0 scale-95' },
                            react_2["default"].createElement(react_1.Menu.Items, { className: 'absolute right-0 z-10 mt-1.5 max-h-96 w-[200px] min-w-[7.2rem] origin-top-right overflow-y-auto whitespace-nowrap rounded-lg bg-white shadow-[0rem_0.25rem_0.375rem_-0.125rem_rgba(26,26,26,.2)] focus:outline-none' },
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'flex items-center justify-between border-b border-gray-200 p-2' },
                                        react_2["default"].createElement("p", null, "C\u00E0i \u0111\u1EB7t"))),
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'cursor-pointer p-2 text-xs hover:bg-gray-100' }, "Th\u00F4ng tin c\u00E1 nh\u00E2n")),
                                react_2["default"].createElement(react_1.Menu.Item, null,
                                    react_2["default"].createElement("div", { className: 'cursor-pointer p-2 text-xs hover:bg-gray-100', onClick: handelLogout }, "\u0110\u0103ng xu\u1EA5t"))))))),
            react_2["default"].createElement("div", { className: "relative hidden  grow flex-col gap-y-3 overflow-y-auto border-r border-gray-200 bg-[#ebebeb] px-6  lg:fixed lg:inset-y-0 lg:z-10 lg:flex ".concat(isOpen ? 'lg:w-[15rem]' : 'lg:w-[3.8rem] lg:overflow-hidden') },
                react_2["default"].createElement("div", { className: "flex h-16 shrink-0 items-center ".concat(!isOpen && 'justify-center') }, isOpen ? (react_2["default"].createElement("a", { href: '/dashboard' },
                    react_2["default"].createElement("img", { alt: 'Your Company', className: 'mt-2 h-[2rem] w-auto', src: phenikaaLogo }))) : (react_2["default"].createElement("span", { className: '-m-4 h-7 w-7' },
                    react_2["default"].createElement("svg", { className: 'h-full w-full', fill: 'none', viewBox: '0 0 216 215', xmlns: 'http://www.w3.org/2000/svg' },
                        react_2["default"].createElement("path", { d: 'M63.2355 14.6823C76.3819 5.05173 92.6621 -0.222122 108.942 0.00717597C126.063 -0.0692568 142.955 5.96893 156.331 16.5931C168.254 25.9179 177.044 38.9114 181.935 53.2043C173.375 42.5038 162.904 33.179 150.522 26.9115C130.726 16.6695 107.108 14.0708 85.4774 19.7268C65.452 24.7714 47.6432 37.0006 35.0318 53.2808C40.2292 37.9942 50.089 24.1599 63.2355 14.6823Z', fill: '#F26522' }),
                        react_2["default"].createElement("path", { d: 'M7.82172 69.3317C13.5542 54.0451 22.9554 40.1344 34.8025 28.8987C27.0828 43.956 22.7261 60.7712 22.879 77.7393C22.6497 104.949 33.8088 132.006 52.917 151.268C66.9806 165.866 85.4009 176.108 105.197 180.465C125.528 185.051 147.235 183.369 166.649 175.726C183.006 169.306 197.451 158.682 208.84 145.382C197.528 175.115 172.458 199.42 142.114 209.204C127.057 214.019 110.929 216.312 95.2608 213.866C78.9042 211.879 63.0061 205.993 49.2483 196.974C31.363 185.204 17.2229 168.006 9.04464 148.21C-1.27378 123.37 -1.73237 94.5545 7.82172 69.3317Z', fill: 'white' }),
                        react_2["default"].createElement("path", { d: 'M182.623 29.3574C194.547 40.8988 203.948 55.0388 209.527 70.7075C216.636 90.6565 217.859 112.898 212.432 133.382C192.712 158.529 161.069 173.815 129.197 173.662C125.732 173.662 122.292 173.56 118.878 173.357C131.413 167.854 143.26 160.669 153.273 151.344C164.662 140.949 173.833 128.108 180.101 114.045C191.872 87.5992 192.942 56.4146 182.623 29.3574Z', fill: 'white' }))))),
                renderNavigation()),
            react_2["default"].createElement("button", { className: "absolute hidden ".concat(isOpen ? 'left-[15rem]' : 'left-[3rem]', " top-4 z-50 flex h-6 w-6 rounded-full bg-[#fe8d59] p-2 text-[#374151] "), onClick: isOpen ? closeNav : openNav, type: 'button' }, isOpen ? (react_2["default"].createElement(react_fontawesome_1.FontAwesomeIcon, { className: 'm-auto h-4 w-4', icon: free_solid_svg_icons_1.faCaretLeft })) : (react_2["default"].createElement(react_fontawesome_1.FontAwesomeIcon, { className: 'm-auto h-4 w-4', icon: free_solid_svg_icons_1.faCaretRight }))),
            react_2["default"].createElement("div", { className: " flex-1  ".concat(isOpen ? 'lg:ml-[15rem]' : 'lg:ml-[4rem]') },
                react_2["default"].createElement("main", { className: 'py-2 md:py-4' },
                    react_2["default"].createElement("div", { className: 'px-4 sm:px-8' }, children))))));
}
exports.PBFMainWrap = PBFMainWrap;
var templateObject_1;
//# sourceMappingURL=PbfMainWrap.js.map