"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var types_1 = require("../../types");
var Checkbox_1 = require("../../Checkbox");
var Dropdown_1 = require("../../Dropdown");
var Radio_1 = require("../../Radio");
function List(_a) {
    var filteredItems = _a.filteredItems, dataSelected = _a.dataSelected, bulkActions = _a.bulkActions, itemFocusId = _a.itemFocusId, readonly = _a.readonly, shortcutAction = _a.shortcutAction, isOptionList = _a.isOptionList, defaultOptionActive = _a.defaultOptionActive, onClickItem = _a.onClickItem, setDataSelected = _a.setDataSelected, isBadge = _a.isBadge, onBulkActions = _a.onBulkActions, actionSelectAll = _a.actionSelectAll, checkRounded = _a.checkRounded;
    var handleClick = function (item) {
        if (onClickItem && !readonly) {
            onClickItem(item);
        }
        else {
            return;
        }
    };
    var _b = (0, react_1.useState)(defaultOptionActive), currentItem = _b[0], setCurrentItem = _b[1];
    var handleSelectOne = function (e, item, type) {
        if (type === 'checkbox') {
            var data = e.target.checked
                ? // @ts-ignore
                 tslib_1.__spreadArray(tslib_1.__spreadArray([], dataSelected, true), [item], false) : dataSelected.filter(function (p) { return p !== item; });
            setDataSelected(data);
            if (onBulkActions && !actionSelectAll) {
                onBulkActions(data);
            }
        }
        else {
            setCurrentItem(item);
            onBulkActions(item);
        }
    };
    return (react_1["default"].createElement(react_1["default"].Fragment, null, filteredItems === null || filteredItems === void 0 ? void 0 : filteredItems.map(function (item, index) { return (react_1["default"].createElement("div", { key: index, "aria-hidden": true, className: (0, types_1.classNames)('p-3', index < filteredItems.length - 1 && 'border-b', index === 0 && !checkRounded && 'rounded-t-lg', index === filteredItems.length - 1 && dataSelected.length === 0 && 'rounded-b-lg', dataSelected.includes(item) && 'bg-bgcl-50', readonly ? '' : 'hover:bg-bgcl-100 hover:cursor-pointer', itemFocusId && (item === null || item === void 0 ? void 0 : item.id) && itemFocusId === item.id ? 'bg-bgcl-100' : ''), onClick: function () { return handleClick(item); } }, onClickItem ? (react_1["default"].createElement("div", { className: 'flex gap-x-1.5 items-center' },
        (bulkActions || isOptionList) && (react_1["default"].createElement("div", { "aria-hidden": true, onClick: function (e) { return e.stopPropagation(); } }, bulkActions ? (react_1["default"].createElement(Checkbox_1.PHXCheckbox, { id: "checkbox-".concat(index), checked: dataSelected.includes(item), onChange: function (e) { return handleSelectOne(e, item, 'checkbox'); } })) : (react_1["default"].createElement(Radio_1.PHXRadio, { id: "radio-".concat(index), checked: (currentItem === null || currentItem === void 0 ? void 0 : currentItem.id) === (item === null || item === void 0 ? void 0 : item.id), onChange: function (e) { return handleSelectOne(e, item, 'radio'); } })))),
        react_1["default"].createElement("div", { className: 'flex-1 flex gap-x-1.5 items-center' },
            (item === null || item === void 0 ? void 0 : item.avatar) && react_1["default"].createElement("img", { alt: 'avatar', className: 'h-8 w-8 rounded-lg mr-2', src: item.avatar }),
            react_1["default"].createElement("div", { className: 'flex flex-col gap-y-0.5' },
                (item === null || item === void 0 ? void 0 : item.name) && react_1["default"].createElement("p", { className: 'text-xs font-medium text-gray-900' }, item.name),
                (item === null || item === void 0 ? void 0 : item.location) && (react_1["default"].createElement("p", { className: "text-xs ".concat(isBadge ? 'mt-1' : '', " font-normal text-gray-600") }, item.location)))),
        shortcutAction && (react_1["default"].createElement("div", { className: 'flex items-center', "aria-hidden": true, onClick: function (e) { return e.stopPropagation(); } },
            react_1["default"].createElement(Dropdown_1.PHXDropdown, { type: 'ellipsis-icon', origin: 'right', options: shortcutAction(item) }))))) : (react_1["default"].createElement("label", { className: "".concat(readonly ? '' : 'hover:cursor-pointer') },
        react_1["default"].createElement("div", { className: 'flex gap-x-1.5 items-center' },
            bulkActions && (react_1["default"].createElement("div", { "aria-hidden": true, onClick: function (e) { return e.stopPropagation(); } },
                react_1["default"].createElement(Checkbox_1.PHXCheckbox, { id: "checkbox_".concat(index), checked: dataSelected.includes(item), onChange: function (e) {
                        handleSelectOne(e, item, 'checkbox');
                    } }))),
            react_1["default"].createElement("div", { className: 'flex-1 flex gap-x-1.5 items-center' },
                (item === null || item === void 0 ? void 0 : item.avatar) && react_1["default"].createElement("img", { alt: 'avatar', className: 'h-8 w-8 rounded-lg mr-2', src: item.avatar }),
                react_1["default"].createElement("div", { className: 'flex flex-col gap-y-0.5' },
                    (item === null || item === void 0 ? void 0 : item.name) && react_1["default"].createElement("p", { className: 'text-xs font-medium text-gray-900' }, item.name),
                    (item === null || item === void 0 ? void 0 : item.location) && (react_1["default"].createElement("p", { className: "text-xs ".concat(isBadge ? 'mt-1' : '', " font-normal text-gray-600") }, item.location)))),
            shortcutAction && (react_1["default"].createElement("div", { className: 'flex items-center', "aria-hidden": true, onClick: function (e) { return e.stopPropagation(); } },
                react_1["default"].createElement(Dropdown_1.PHXDropdown, { type: 'ellipsis-icon', origin: 'right', options: shortcutAction(item) })))))))); })));
}
exports["default"] = List;
//# sourceMappingURL=list.js.map