"use strict";
exports.__esModule = true;
exports.PHXTableLogImportExport = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var Badge_1 = require("../Badge");
var FormWrap_1 = require("../FormWrap");
var Table_1 = require("../Table");
var apollo_wrapper_1 = require("../../lib/apollo-wrapper");
var read_env_config_1 = require("../../read-env-config");
var keyActionImport = 0;
var PHXTableLogImportExport = function (_a) {
    var actionType = _a.actionType, organizationCode = _a.organizationCode;
    var _b = (0, react_1.useState)(0), pagination = _b[0], setPagination = _b[1];
    var paginationData = function (pagi) {
        setPagination(pagi);
    };
    var _c = (0, react_1.useState)('created_at'), fieldSort = _c[0], setFieldSort = _c[1];
    var _d = (0, react_1.useState)('desc'), sortDirection = _d[0], setSortDirection = _d[1];
    var sortData = function (fieldSortParams, sortDirectionParams) {
        setFieldSort(fieldSortParams);
        setSortDirection(sortDirectionParams);
    };
    var dateStrToDate = function (date) {
        return date ? date.slice(8, 10) + '/' + date.slice(5, 7) + '/' + date.slice(0, 4) : '';
    };
    var list = function (paginationParams, fieldSortParams, sortDirectionParams, organizationCodeParams, actionTypeParams) {
        return {
            keyResult: 'feature_import_export_file_history',
            query: "query getListUploadFileHistory {\n                        feature_import_export_file_history(\n                          limit: 10,\n                          offset: ".concat(paginationParams * 10, ", \n                          order_by: {").concat(fieldSortParams, ": ").concat(sortDirectionParams, "}\n                          where: {\n                              deleted_at: {_is_null: true}, organization_code: {_eq: ").concat(organizationCodeParams, "},action_type: {_eq: ").concat(actionTypeParams, "}}\n                          ) {\n                            id\n                            file_name\n                            file_path\n                            file_type\n                            import_event_code\n                            module_id\n                            project_name\n                            status\n                            created_at\n                        }\n      \n                        feature_import_export_file_history_aggregate(where: {deleted_at: {_is_null: true}, organization_code: {_eq: ").concat(organizationCodeParams, "},action_type: {_eq: ").concat(actionTypeParams, "}}) {\n                          aggregate {\n                          count\n                          }\n                      }\n                    }")
        };
    };
    var search = function (paginationParams, fieldSortParams, sortDirectionParams, organizationCodeParams, actionTypeParams) {
        return {
            enable: false,
            keyResult: 'feature_import_export_file_history',
            query: "query getListUploadFileHistoryBySearch {\n                  feature_import_export_file_history(\n                      limit: 10, \n                      offset: ".concat(paginationParams * 10, ",\n                      order_by: {").concat(fieldSortParams, ": ").concat(sortDirectionParams, "},\n                      where: {_or: [{import_event_code: {_ilike: \"%@value%\"}}, {project_name: {_ilike: \"%@value%\"}}], deleted_at: {_is_null: true}, organization_code: {_eq: ").concat(organizationCodeParams, "},action_type: {_eq: ").concat(actionTypeParams, "}}\n                  ){\n                    id\n                    file_name\n                    file_path\n                    file_type\n                    import_event_code\n                    module_id\n                    project_name\n                    status\n                    created_at\n                  }\n      \n                  feature_import_export_file_history_aggregate(\n                    where: {_or: [{import_event_code: {_ilike: \"%@value%\"}}, {project_name: {_ilike: \"%@value%\"}}], deleted_at: {_is_null: true}, organization_code: {_eq: ").concat(organizationCodeParams, "},action_type: {_eq: ").concat(actionTypeParams, "}}\n                    ){\n                        aggregate {\n                        count\n                        }\n                    }\n              }")
        };
    };
    var thHeader = ['Tên file', 'Đường dẫn file', 'Tên dự án', 'Tên module', 'Trạng thái', 'Ngày tạo'];
    var thBody = ['id', 'file_name', 'file_path', 'project_name', 'module_id', 'status', 'created_at'];
    var thComponent = {
        // @ts-ignore
        created_at: function bind(value, itemBody) {
            return dateStrToDate(itemBody.created_at);
        },
        // @ts-ignore
        status: function bind(value, itemBody) {
            switch (itemBody === null || itemBody === void 0 ? void 0 : itemBody.status) {
                case 0:
                    return react_1["default"].createElement(Badge_1.PHXBadge, { text: 'Nh\u00E1p', type: 'default' });
                case 1:
                    return react_1["default"].createElement(Badge_1.PHXBadge, { text: 'Ch\u1EDD x\u1EED l\u00FD', type: 'informational' });
                case 2:
                    return react_1["default"].createElement(Badge_1.PHXBadge, { text: '\u0110ang x\u1EED l\u00FD', type: 'attention' });
                case 3:
                    return react_1["default"].createElement(Badge_1.PHXBadge, { text: 'Th\u00E0nh c\u00F4ng', type: 'success' });
                default:
                    return react_1["default"].createElement(Badge_1.PHXBadge, { text: 'Th\u1EA5t b\u1EA1i', type: 'danger' });
            }
        }
    };
    var listQuery = list(pagination, fieldSort, sortDirection, organizationCode, actionType);
    var searchQuery = search(pagination, fieldSort, sortDirection, organizationCode, actionType);
    return (react_1["default"].createElement(FormWrap_1.PHXFormWrap, { className: 'text-xs', footerAction: false, headerAction: true, size: 'medium', title: actionType === keyActionImport ? 'Những file đã import' : 'Những file đã export', type: 'default' },
        react_1["default"].createElement(apollo_wrapper_1.ApolloWrapper, null,
            react_1["default"].createElement(Table_1.PHXTable, { clickRow: false, graphqlEndpoint: (0, read_env_config_1.getEnv)('NEXT_PUBLIC_GRAPHQL_API_PROCESS_CENTER', process.env.NEXT_PUBLIC_GRAPHQL_API_PROCESS_CENTER), graphqlKey: (0, read_env_config_1.getEnv)('NEXT_PUBLIC_GRAPHQL_KEY_PROCESS_CENTER', process.env.NEXT_PUBLIC_GRAPHQL_KEY_PROCESS_CENTER), list: listQuery, paginationData: paginationData, search: searchQuery, sortData: sortData, thBody: thBody, thBodyComponent: thComponent, thHeader: thHeader, router: undefined }))));
};
exports.PHXTableLogImportExport = PHXTableLogImportExport;
//# sourceMappingURL=TableLogImportExport.js.map