"use strict";
'use client';
exports.__esModule = true;
exports.ApolloWrapper = void 0;
var tslib_1 = require("tslib");
var client_1 = require("@apollo/client");
var ssr_1 = require("@apollo/experimental-nextjs-app-support/ssr");
var react_1 = tslib_1.__importDefault(require("react"));
var getHttpLinkConfig_1 = tslib_1.__importDefault(require("../components/Func/getHttpLinkConfig"));
function makeClient() {
    var httpLink = (0, getHttpLinkConfig_1["default"])();
    return new ssr_1.NextSSRApolloClient({
        cache: new ssr_1.NextSSRInMemoryCache(),
        link: typeof window === 'undefined'
            ? client_1.ApolloLink.from([
                new ssr_1.SSRMultipartLink({
                    stripDefer: true
                }),
                httpLink,
            ])
            : httpLink
    });
}
// eslint-disable-next-line no-undef
function ApolloWrapper(_a) {
    var children = _a.children;
    return react_1["default"].createElement(ssr_1.ApolloNextAppProvider, { makeClient: makeClient }, children);
}
exports.ApolloWrapper = ApolloWrapper;
//# sourceMappingURL=apollo-wrapper.js.map