import { __assign, __awaiter, __generator } from "tslib";
import { getEnv } from '../../read-env-config';
import { requestMaxDuration } from '../../utils/constants';
export default function PHXClientMutation(mutationName, option, customHeaders, isDelay) {
    if (isDelay === void 0) { isDelay = true; }
    return __awaiter(this, void 0, void 0, function () {
        var startTime, env, uri, fullUrl, headers, mutationResult, endTime, duration;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    startTime = performance.now();
                    env = getEnv('NEXT_PUBLIC_ENV', process.env.NEXT_PUBLIC_ENV);
                    uri = getEnv('NEXT_PUBLIC_API', process.env.NEXT_PUBLIC_API);
                    fullUrl = typeof window === 'undefined' ? '' : window.location.href;
                    headers = __assign(__assign({}, customHeaders), { 'Full-Url': fullUrl });
                    if (!(env === 'local')) return [3 /*break*/, 2];
                    return [4 /*yield*/, mutationName(__assign(__assign({}, option), { context: {
                                uri: uri,
                                headers: headers
                            } }))];
                case 1:
                    mutationResult = _a.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, mutationName(__assign(__assign({}, option), { context: { uri: "".concat(uri, "/graphql/ms/v1/graphql"), headers: headers } }))];
                case 3:
                    mutationResult = _a.sent();
                    _a.label = 4;
                case 4:
                    endTime = performance.now();
                    duration = endTime - startTime;
                    if (!(duration < requestMaxDuration && isDelay)) return [3 /*break*/, 6];
                    console.info('promise delay...');
                    return [4 /*yield*/, new Promise(function (r) { return setTimeout(r, 100); })];
                case 5:
                    _a.sent();
                    _a.label = 6;
                case 6: return [2 /*return*/, mutationResult];
            }
        });
    });
}
//# sourceMappingURL=clientMutationV2.js.map