import { useLazyQuery } from '@apollo/client';
import { useState, useEffect } from 'react';
import PHXFuncGetLoggedInfo from './getLoginInfo';
import { getActiveAndNextSchoolYear } from '../../query/gql';
import PHXClientQuery from './clientQueryV2';
function PHXGetActiveYearAndNextYear() {
    var schoolInfo = PHXFuncGetLoggedInfo();
    var _a = useState([]), listSchoolYear = _a[0], setListSchoolYear = _a[1];
    var currentDate = new Date();
    currentDate.setFullYear(currentDate.getFullYear() + 1);
    var timeYearActive = new Date().toISOString().slice(0, 10);
    var nextYearDate = currentDate.toISOString().slice(0, 10);
    var _b = useLazyQuery(getActiveAndNextSchoolYear, {
        fetchPolicy: 'network-only',
        notifyOnNetworkStatusChange: true
    }), getActiveSchoolYearInfo = _b[0], schoolYearData = _b[1].data;
    useEffect(function () {
        PHXClientQuery(getActiveSchoolYearInfo, {
            variables: {
                endAt: timeYearActive,
                startAt: nextYearDate,
                school_id: schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id
            }
        });
    }, []);
    useEffect(function () {
        if ((schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) && schoolYearData.school_year.length > 0) {
            // @ts-ignore
            var arraySchoolYear = (schoolYearData === null || schoolYearData === void 0 ? void 0 : schoolYearData.school_year) || [];
            setListSchoolYear(arraySchoolYear);
        }
        else {
            setListSchoolYear([]);
        }
    }, [schoolYearData]);
    return listSchoolYear;
}
export default PHXGetActiveYearAndNextYear;
//# sourceMappingURL=getActiveAndNextSchoolYear.js.map