import { __assign, __awaiter, __generator } from "tslib";
import { ApolloClient, InMemoryCache } from '@apollo/client';
import { INSERT_USER_ACTIVITY_MUTATION } from '../../query/userActivity/mutation';
import { getEnv } from '../../read-env-config';
import Cookies from 'js-cookie';
import { AUTH_TOKEN } from '../../utils/constants';
import PHXFuncGetLoggedInfo from './getLoginInfo';
function generatePayload(data, user_id, school_id) {
    return __assign(__assign({}, data), { school_id: school_id, user_id: user_id });
}
export var PHXLogUserActivity = function (data) { return __awaiter(void 0, void 0, void 0, function () {
    var uri, authTokenInfo, schoolInfo, userId, schoolId, payload, client, res, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                uri = getEnv('NEXT_PUBLIC_API', process.env.NEXT_PUBLIC_API);
                authTokenInfo = Cookies.get(AUTH_TOKEN) && JSON.parse(Cookies.get(AUTH_TOKEN));
                schoolInfo = PHXFuncGetLoggedInfo();
                userId = schoolInfo.id;
                schoolId = schoolInfo === null || schoolInfo === void 0 ? void 0 : schoolInfo.school_id;
                payload = generatePayload(data, userId, schoolId);
                client = new ApolloClient({
                    uri: uri,
                    cache: new InMemoryCache(),
                    headers: {
                        Authorization: 'Bearer' + ' ' + authTokenInfo.token,
                        'Content-Type': 'application/json'
                    }
                });
                return [4 /*yield*/, client.mutate({
                        mutation: INSERT_USER_ACTIVITY_MUTATION,
                        variables: payload
                    })];
            case 1:
                res = _a.sent();
                return [2 /*return*/, res];
            case 2:
                err_1 = _a.sent();
                console.log(err_1);
                return [2 /*return*/, []];
            case 3: return [2 /*return*/];
        }
    });
}); };
//# sourceMappingURL=logUserActivity.js.map