import { Disclosure, Transition } from '@headlessui/react';
import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
import React from 'react';
function classNames() {
    var classes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        classes[_i] = arguments[_i];
    }
    return classes.filter(Boolean).join(' ');
}
export default function NavMobileContent(_a) {
    var pathName = _a.pathName, menu = _a.menu, router = _a.router, permission = _a.permission, setSideBarOpen = _a.setSideBarOpen;
    var closeSideBar = function (item, parent) {
        var currentPath = pathName.split('/');
        var parentPath = parent.path.split('/');
        if (currentPath[1] === parentPath[1]) {
            setSideBarOpen();
            router.push(item.path);
        }
        else {
            window.location.replace("/".concat(parentPath[1]).concat(item.path));
        }
    };
    var activeModule = function (href) {
        var pathNameSplit = pathName.split('/');
        var urlRouter1 = pathNameSplit[2];
        var hrefSplit = href.split('/');
        var currentMenu1 = hrefSplit[1];
        return urlRouter1 === currentMenu1;
    };
    function enablePer(code, arr) {
        return arr === null || arr === void 0 ? void 0 : arr.some(function (item) { return item === code; });
    }
    return (React.createElement(React.Fragment, null,
        menu ? (menu.map(function (item) { return (React.createElement(React.Fragment, null, enablePer(item === null || item === void 0 ? void 0 : item.code, permission) &&
            (!item.child ? (React.createElement("div", { key: item.name },
                React.createElement("a", { href: item.path, className: classNames(item.current ? 'font-semibold' : 'text-gray-500 ', 'group w-full flex items-center pl-2 py-2 text-sm font-medium rounded-md') }, item.name))) : (React.createElement(Disclosure, { defaultOpen: item.current, as: 'div', key: item.name, className: 'space-y-1' }, function (_a) {
                var open = _a.open;
                return (React.createElement(React.Fragment, null,
                    React.createElement(Disclosure.Button, { className: classNames(item.current ? 'text-gray-600' : 'text-gray-600', 'group w-full flex items-center pl-2 pr-1 py-2 text-left text-sm font-medium rounded-md focus:outline-none focus:ring-2 focus:ring-indigo-500') },
                        item.menuIconSL ? (React.createElement("img", { src: item.menuIconSL, className: 'w-[1.6rem] mr-2', alt: 'icon' })) : (React.createElement(FontAwesomeIcon, { className: 'h-5 w-5 text-gray-600 group-hover:text-gray-600 mr-2', icon: item.image })),
                        React.createElement("span", { className: 'flex-1 subpixel-antialiased' }, item.name),
                        React.createElement("svg", { className: classNames(open ? 'text-gray-400 rotate-90' : 'text-gray-300', 'ml-3 h-5 w-5 flex-shrink-0 transform transition-colors duration-150 ease-in-out group-hover:text-gray-400'), viewBox: '0 0 20 20', "aria-hidden": 'true' },
                            React.createElement("path", { d: 'M6 6L14 10L6 14V6Z', fill: 'currentColor' }))),
                    React.createElement(Transition, { show: open, enter: 'transition duration-100 ease-out', enterFrom: 'transform scale-95 opacity-0', enterTo: 'transform scale-100 opacity-100', leave: 'transition duration-75 ease-out', leaveFrom: 'transform scale-100 opacity-100', leaveTo: 'transform scale-95 opacity-0' },
                        React.createElement(Disclosure.Panel, { static: false, className: 'space-y-1' }, item.path === '/admissions/campaign/list' && pathName !== '/admissions/campaign/list' ? (React.createElement(React.Fragment, null, item.child
                            .find(function (child) { return child.path === '/campaign/list'; })
                            .childrenByParentDetail.map(function (child, index) { return (React.createElement(React.Fragment, null, enablePer(child === null || child === void 0 ? void 0 : child.code, permission) && (React.createElement("p", { "aria-hidden": true, onClick: function () { return closeSideBar(child, item); }, className: classNames('group flex w-full items-center rounded-md py-[5px] pl-11 pr-2 text-sm font-medium cursor-pointer', activeModule(child.path)
                                ? 'font-semibold bg-white text-gray-900'
                                : ' text-gray-500 hover:bg-gray-200'), key: index }, child.name)))); }))) : (React.createElement(React.Fragment, null, item.child.map(function (subItem, index) { return (React.createElement(React.Fragment, null,
                            enablePer(subItem === null || subItem === void 0 ? void 0 : subItem.code, permission) && (React.createElement("p", { "aria-hidden": true, onClick: function () { return closeSideBar(subItem, item); }, className: classNames('group flex w-full items-center rounded-md py-[5px] pl-11 pr-2 text-sm font-medium cursor-pointer', subItem.current
                                    ? 'font-semibold bg-white text-gray-900'
                                    : ' text-gray-500 hover:bg-gray-200 '), key: index }, subItem.name)),
                            subItem.showChild && subItem.child && (React.createElement(React.Fragment, null, subItem.child.map(function (children) { return (React.createElement("p", { "aria-hidden": true, key: children.name, className: classNames('group flex w-full items-center rounded-md py-[5px] pl-8 pr-2 text-sm font-medium cursor-pointer', (children === null || children === void 0 ? void 0 : children.current)
                                    ? 'rounded-lg bg-white text-gray-900'
                                    : 'hover:rounded-lg hover:bg-white hover:bg-opacity-50 hover:text-gray-900'), onClick: function () { return closeSideBar(children, item); } },
                                React.createElement("div", { className: 'flex items-center gap-x-3' },
                                    React.createElement("div", { className: 'w-3' }),
                                    React.createElement("p", { className: classNames('ml-3 leading-5 my-[0.05rem]', (children === null || children === void 0 ? void 0 : children.current) ? 'font-semibold' : 'text-gray-500 font-normal') }, children.name)))); }))))); })))))));
            }))))); })) : (React.createElement(React.Fragment, null)),
        React.createElement("div", { className: 'fixed bottom-0 transition-all overflow-hidden p-3 w-64' },
            React.createElement("a", { href: '/setting', className: 'text-gray-700 font-medium' },
                React.createElement("span", { className: 'sr-only' }, "setting"),
                React.createElement("span", { className: 'group cursor-pointer hover:z-10 mt-0.5 flex' },
                    React.createElement(FontAwesomeIcon, { className: 'h-5 w-5 mt-0.5', icon: 'fa-solid fa-gear' }),
                    React.createElement("div", { className: 'h-6' },
                        React.createElement("p", { className: 'transition-all h-full text-[0.86rem] setting-text-color mt-0.5 font-semibold ml-2' }, "C\u00E0i \u0111\u1EB7t")))))));
}
//# sourceMappingURL=nav-mobile-content.js.map