import { __awaiter, __generator } from "tslib";
import React, { useEffect, useRef, useState } from 'react';
import { ButtonUpload } from './ButtonUpload';
import { classNames } from '../types';
import { PHXButton } from '../Button';
import { PHXSpinner } from '../Loading';
export function FormUpload(_a) {
    var _this = this;
    var fileName = _a.fileName, fileType = _a.fileType, handleCheckboxChange = _a.handleCheckboxChange, handleFileChange = _a.handleFileChange, helpText = _a.helpText, isImage = _a.isImage, label = _a.label, length = _a.length, link = _a.link, oneImg = _a.oneImg, selectedImages = _a.selectedImages, setIsModalOpen = _a.setIsModalOpen, showImage = _a.showImage;
    var fileInputRef = useRef(null);
    var _b = useState(false), showLargeImage = _b[0], setShowLargeImage = _b[1];
    var _c = useState(''), largeImageUrl = _c[0], setLargeImageUrl = _c[1];
    var _d = useState(fileName), file = _d[0], setFile = _d[1];
    var _e = useState(false), showMoreImage = _e[0], setShowMoreImage = _e[1];
    var _f = useState(false), loading = _f[0], setLoading = _f[1];
    var showSelectedTitle = (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.length) > 0;
    var showButtonWithOneImage = (link === null || link === void 0 ? void 0 : link.length) > 0 && isImage && oneImg;
    var listImage = !showMoreImage ? link === null || link === void 0 ? void 0 : link.slice(0, 10) : link;
    var limitImageShow = 10;
    var handleUploadClick = function () {
        if (fileInputRef.current) {
            fileInputRef.current.click();
        }
    };
    var handleAwaitUpdate = function (event) { return __awaiter(_this, void 0, void 0, function () {
        var e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, 3, 4]);
                    setLoading(true);
                    return [4 /*yield*/, handleFileChange(event)];
                case 1:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 2:
                    e_1 = _a.sent();
                    console.log(e_1);
                    return [3 /*break*/, 4];
                case 3:
                    setLoading(false);
                    if (showMoreImage) {
                        setShowMoreImage(false);
                    }
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        var closeImageOnOutsideClick = function (event) {
            if (showLargeImage) {
                var clickedElement = event.target;
                var imageContainer = document.getElementById('large-image-container');
                if (!(imageContainer === null || imageContainer === void 0 ? void 0 : imageContainer.contains(clickedElement))) {
                    setShowLargeImage(false);
                }
            }
        };
        document.addEventListener('click', closeImageOnOutsideClick);
        return function () {
            document.removeEventListener('click', closeImageOnOutsideClick);
        };
    }, [showLargeImage]);
    var handleImageClick = function (url) {
        setLargeImageUrl(url);
        setShowLargeImage(true);
    };
    useEffect(function () {
        if (fileType === 'image') {
            setFile(null);
        }
    }, [link]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: classNames('mb-1 flex text-xs font-normal text-gray-700', label ? 'justify-between' : '') }, label && React.createElement("label", null, label)),
        React.createElement("div", { className: 'relative' },
            showSelectedTitle && (React.createElement("div", { className: 'absolute inset-x-0 -top-8 flex justify-between bg-white pb-2' },
                React.createElement("div", { className: 'flex items-center' },
                    React.createElement("div", { className: '-pl-2 text-sm leading-5 text-[#111827]' },
                        length,
                        " file \u0111\u00E3 \u0111\u01B0\u1EE3c ch\u1ECDn")),
                React.createElement(PHXButton, { deleted: true, onClick: function () { return setIsModalOpen(true); }, size: 'micro' }, "X\u00F3a"))),
            isImage && (React.createElement("div", { className: "".concat(oneImg ? ' flex justify-center rounded-lg bg-gray-100' : 'grid grid-cols-6 gap-2') }, listImage === null || listImage === void 0 ? void 0 :
                listImage.map(function (src, index) {
                    var isSelectImage = (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.length) > 0;
                    return (React.createElement("div", { key: index, className: "group relative  overflow-hidden  border ".concat(!oneImg ? 'aspect-square rounded-[10px] ' : '') },
                        React.createElement("img", { alt: 'img', className: " object-contain ".concat(oneImg ? 'max-h-[180px]' : 'h-full w-full object-contain'), src: src }),
                        React.createElement("button", { className: "absolute inset-0 flex items-center justify-center bg-black  text-white opacity-0 transition-opacity duration-300 group-hover:opacity-100 ".concat(!oneImg ? 'bg-opacity-60' : 'bg-opacity-0'), onClick: function () {
                                if (isSelectImage) {
                                    handleCheckboxChange(index);
                                }
                                else {
                                    handleImageClick(src);
                                }
                            }, type: 'button' }),
                        !oneImg && (React.createElement("div", { className: "z-8 absolute left-[0.3rem] top-0 opacity-0 ".concat((selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.length) > 0 ? 'opacity-100' : 'group-hover:opacity-100') },
                            React.createElement("input", { checked: selectedImages.includes(index), className: 'h-[16px] w-[16px] cursor-pointer rounded-[4px]   text-black  checked:bg-black checked:ring-0 focus:outline-none focus:ring-0', onChange: function () { return handleCheckboxChange(index); }, type: 'checkbox' })))));
                }),
                !showMoreImage && (link === null || link === void 0 ? void 0 : link.length) > limitImageShow && (React.createElement("div", { className: 'group relative aspect-square overflow-hidden rounded-lg border' },
                    React.createElement("img", { alt: 'img', className: 'mx-auto h-full object-cover', src: link === null || link === void 0 ? void 0 : link[limitImageShow + 1] }),
                    React.createElement("button", { className: 'absolute inset-0 flex items-center justify-center bg-black bg-opacity-60 text-white backdrop-blur-sm  transition-opacity duration-300 ', onClick: function () { return setShowMoreImage(true); }, type: 'button' },
                        React.createElement("p", null,
                            "+",
                            ((link === null || link === void 0 ? void 0 : link.length) || 0) - limitImageShow)))),
                (link === null || link === void 0 ? void 0 : link.length) > 0 && !oneImg && (React.createElement("button", { className: '  flex  aspect-square items-center justify-center rounded-lg border border-dashed border-gray-300 bg-[#F7F7F7] transition-all hover:bg-[#f1f1f1]', onClick: handleUploadClick, type: 'button' }, loading ? (React.createElement(PHXSpinner, null)) : (React.createElement("svg", { className: 'h-5 w-5', fill: 'none', stroke: 'currentColor', strokeWidth: '1.5', viewBox: '0 0 24 24', xmlns: 'http://www.w3.org/2000/svg' },
                    React.createElement("path", { d: 'M12 4.5v15m7.5-7.5h-15', strokeLinecap: 'round', strokeLinejoin: 'round' }))))),
                showLargeImage && (React.createElement("div", { className: 'fixed left-0 top-0 z-50 flex h-full w-full items-center justify-center bg-black bg-opacity-70', id: 'large-image-container', onClick: function () { return setShowLargeImage(false); } },
                    React.createElement("img", { alt: 'Large Image', className: 'max-h-full max-w-full', onClick: function (e) { return e.stopPropagation(); }, src: largeImageUrl }))))),
            showButtonWithOneImage && (React.createElement("div", { className: ' mt-3  flex  gap-2 ' },
                React.createElement(PHXButton, { loading: loading, onClick: handleUploadClick, secondary: true, size: 'micro' }, "Thay \u0111\u1ED5i"),
                React.createElement(PHXButton, { deleted: true, onClick: function () { return setIsModalOpen(true); }, size: 'micro' }, "Xo\u00E1 \u1EA3nh"))),
            (link === null || link === void 0 ? void 0 : link.length) === 0 && (React.createElement(React.Fragment, null, !file ? (React.createElement("div", { className: 'flex cursor-pointer flex-col justify-center rounded-lg border border-dashed border-gray-900/25 px-5 pb-8 pt-8 hover:bg-[#f7f7f7]' },
                React.createElement("div", { className: 'flex flex-col items-center justify-center' },
                    React.createElement(ButtonUpload, { fileType: fileType, handleUploadClick: function () {
                            handleUploadClick();
                        }, helpText: helpText, loading: loading })))) : (React.createElement("div", { className: 'w-full' },
                React.createElement("div", { className: 'mx-auto max-w-3xl px-5 pb-3 lg:max-w-full lg:px-0' },
                    React.createElement("div", { className: 'flex items-center justify-between rounded-lg border border-gray-200 bg-white shadow-[0rem_0.0825rem_0rem_#00000012]' },
                        React.createElement("div", { className: 'h-full bg-gray-200 p-6' },
                            React.createElement("svg", { "aria-hidden": 'true', className: 'h-5 w-5', focusable: 'false', viewBox: '0 0 20 20' },
                                React.createElement("path", { d: 'M6.75 4c-.69 0-1.25.56-1.25 1.25v9.5c0 .69.56 1.25 1.25 1.25h6.5c.69 0 1.25-.56 1.25-1.25v-9a.75.75 0 0 1 1.5 0v9a2.75 2.75 0 0 1-2.75 2.75h-6.5a2.75 2.75 0 0 1-2.75-2.75v-9.5a2.75 2.75 0 0 1 2.75-2.75h3a2.75 2.75 0 0 1 2.75 2.75v6.25a2.5 2.5 0 0 1-5 0v-5.5a.75.75 0 0 1 1.5 0v5.5a1 1 0 1 0 2 0v-6.25c0-.69-.56-1.25-1.25-1.25h-3Z', fillRule: 'evenodd' }))),
                        React.createElement("p", { className: 'w-60 truncate px-2 text-sm text-gray-600 lg:w-72' }, fileName),
                        React.createElement("div", { className: 'min-w-[20%]' },
                            React.createElement(PHXButton, { loading: loading, onClick: handleUploadClick, secondary: true, size: 'micro' }, "Thay \u0111\u1ED5i")))))))),
            (link === null || link === void 0 ? void 0 : link.length) > 0 && !isImage && (React.createElement("div", { className: 'flex cursor-pointer flex-col justify-center rounded-lg border border-dashed border-gray-900/25 px-5 pb-8 pt-8 hover:bg-[#f7f7f7]' },
                React.createElement("div", { className: 'flex flex-col items-center justify-center' }, fileType === 'file' && !showImage ? (React.createElement("div", { className: 'flex h-full items-center justify-center rounded-lg py-6 ' },
                    React.createElement(PHXSpinner, { className: 'h-5 w-5' }))) : (React.createElement(React.Fragment, null,
                    React.createElement("p", { className: 'mt-2 text-sm text-gray-600' }, fileName),
                    React.createElement(ButtonUpload, { fileType: fileType, handleUploadClick: handleUploadClick, helpText: helpText, loading: loading }))))))),
        React.createElement("input", { ref: fileInputRef, accept: "".concat((fileType === 'excel' && '.xlsx, .xls') ||
                (fileType === 'image' && '.jpg, .jpeg, .png, .gif, .webp') ||
                (fileType === 'file' && '.pdf, .png,.jpg, .jpeg')), className: 'sr-only', id: 'file-upload', name: 'file-upload', onChange: handleAwaitUpdate, type: 'file' })));
}
//# sourceMappingURL=FormUpload.js.map