'use client';
import { ApolloLink } from '@apollo/client';
import { ApolloNextAppProvider, NextSSRInMemoryCache, SSRMultipartLink, NextSSRApolloClient, } from '@apollo/experimental-nextjs-app-support/ssr';
import React from 'react';
import PHXGetHttpLinkConfig from '../components/Func/getHttpLinkConfig';
function makeClient() {
    var httpLink = PHXGetHttpLinkConfig();
    return new NextSSRApolloClient({
        cache: new NextSSRInMemoryCache(),
        link: typeof window === 'undefined'
            ? ApolloLink.from([
                new SSRMultipartLink({
                    stripDefer: true
                }),
                httpLink,
            ])
            : httpLink
    });
}
// eslint-disable-next-line no-undef
export function ApolloWrapper(_a) {
    var children = _a.children;
    return React.createElement(ApolloNextAppProvider, { makeClient: makeClient }, children);
}
//# sourceMappingURL=apollo-wrapper.js.map