export declare const querySchoolYearV3 = "\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, end_at: { _gte: $gte }, start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        start_at\n        end_at\n      }\n    }\n  }\n";
export declare const getActiveAndNextSchoolYearV3 = "\n  query GetActiveAndNextSchoolYear($startAt: timestamptz, $endAt: timestamptz, $school_id: Int) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        start_at: { _lte: $startAt }\n        end_at: { _gte: $endAt }\n        school_course: { school_id: { _eq: $school_id } }\n      }\n      order_by: { id: asc }\n    ) {\n      code\n      end_at\n      id\n      name\n      start_at\n      school_terms(where: { deleted_at: { _is_null: true } }, order_by: { id: asc }) {\n        name\n        code\n        id\n      }\n      school_course {\n        course_name\n        id\n        code\n      }\n    }\n  }\n";
export declare const querySchoolYearHocvuV3 = "\n  query MyQuery($school_id: Int!, $gte: timestamptz!, $lte: timestamptz!) {\n    school_year(\n      where: {\n        deleted_at: { _is_null: true }\n        school_course: { school_id: { _eq: $school_id } }\n        end_at: { _gte: $gte }\n        start_at: { _lte: $lte }\n      }\n    ) {\n      id\n      name\n      code\n      start_at\n      end_at\n      school_terms(where: { deleted_at: { _is_null: true } }) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n      current_term: school_terms(\n        where: { deleted_at: { _is_null: true }, hoc_vu_end_at: { _gte: $gte }, hoc_vu_start_at: { _lte: $lte } }\n      ) {\n        id\n        code\n        name\n        coefficient\n        hoc_vu_start_at\n        hoc_vu_end_at\n      }\n    }\n  }\n";
